Differences between revisions 1 and 2
Revision 1 as of 2010-08-18 16:20:29
Size: 1433
Editor: GreyCat
Comment: Why doesn't set -e (set -o errexit) do what I expected?
Revision 2 as of 2010-08-18 16:25:07
Size: 1431
Editor: GreyCat
Comment: err, yeah, that blank line can't be there.
Deletions are marked like this. Additions are marked like this.
Line 3: Line 3:

Why doesn't set -e (set -o errexit) do what I expected?

set -e was an attempt to add "automatic error detection" to the shell. Its goal was to cause the shell to abort any time an error occurred, so you don't have to put || exit 1 after each important command.

That goal is non-trivial, because many commands are supposed to return non-zero. For example,

  if [ -d /foo ]; then
    ...
  else
    ...
  fi

If the [ -d /foo ] command triggers the set -e abort when it returns non-zero (because the directory does not exist -- a case our script wants to handle in the else part), then obviously set -e isn't very useful. So the implementors decided to make a bunch of special rules, like "commands that are part of an if test are immune", or "commands in a pipeline, other than the last one, are immune".

These rules are extremely convoluted. Worse, they change from one Bash version to another, as Bash attempts to track the extremely slippery POSIX definition of this "feature". When a SubShell is involved, it gets worse still. The behavior changes depending on whether Bash is invoked in POSIX mode. Another wiki has a page that covers this in more detail. Be sure to check the caveats.

GreyCat's personal recommendation is simple: don't use it. Add your own explicit error checking instead.

BashFAQ/105 (last edited 2021-03-11 06:07:25 by dsl-66-36-156-249)